<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelVendasDlvOperaService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function find($CDFILIAL, $NRORG, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
         	':CDFILIAL' => $CDFILIAL,
         	':NRORG' => $NRORG,
         	':DTVENDAINI' => $DTVENDAINI,
         	':DTVENDAFIN' => $DTVENDAFIN
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_VENDAS_DELIVERY_OPERADOR, $params);
    }

    const GET_VENDAS_DELIVERY_OPERADOR = "
            SELECT SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) + NVL(I.VRACRITVEND,0) - NVL(I.VRDESITVEND,0))-FILOCAVEOP.VRTXSEVENDA AS VRTOTAL,
                   (SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) + NVL(I.VRACRITVEND,0) - NVL(I.VRDESITVEND,0))-FILOCAVEOP.VRTXSEVENDA)*(FILOCAVEOP.VRCOMISVENDA/100) AS VRCOMIS,
                   FILOCAVEOP.NMOPERADOR, FILOCAVEOP.IDSITUVENDA, FILOCAVEOP.NRSEQVENDA, FILOCAVEOP.CDCAIXA, FILOCAVEOP.NMCAIXA, FILOCAVEOP.CDLOJA, FILOCAVEOP.NMLOJA, FILOCAVEOP.CDFILIAL, 
                   FILOCAVEOP.NMFILIAL, FILOCAVEOP.CUPOM, FILOCAVEOP.CDOPERADOR, FILOCAVEOP.NRORG, FILOCAVEOP.CDFILIAL||' - '||FILOCAVEOP.NMFILIAL AS LABELFILIAL,
                   FILOCAVEOP.CDOPERADOR||' - '||FILOCAVEOP.NMOPERADOR AS LABELOPERADOR,
                   FILOCAVEOP.DTVENDA, FILOCAVEOP.VRTXSEVENDA, FILOCAVEOP.VRCOMISVENDA, FILOCAVEOP.QTD
              FROM ITEMVENDA I 
              JOIN (SELECT O.NMOPERADOR, FILOCAVE.IDSITUVENDA, FILOCAVE.NRSEQVENDA, FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL, 
                           FILOCAVE.NMFILIAL, FILOCAVE.CUPOM, FILOCAVE.CDOPERADOR, FILOCAVE.NRORG, FILOCAVE.DTVENDA, FILOCAVE.VRTXSEVENDA, FILOCAVE.VRCOMISVENDA, COUNT(FILOCAVE.CUPOM) OVER (PARTITION BY FILOCAVE.CDOPERADOR, FILOCAVE.NRORG)AS QTD
                     FROM OPERADOR O
                     JOIN  (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, 
                                   FILOCA.NMFILIAL, NVL(V.NRNOTAFISCALCE, V.NRCUPOMFIS) AS CUPOM, V.CDOPERADOR, FILOCA.NRORG, V.DTVENDA, V.VRTXSEVENDA, FILOCA.VRCOMISVENDA
                              FROM VENDA V
                              JOIN ( SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.VRCOMISVENDA
                                       FROM CAIXA C
                                       JOIN ( SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.VRCOMISVENDA
                                                FROM LOJA L
                                                JOIN ( SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                                         FROM FILIAL F
                                                        WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                          AND F.NRORG = :NRORG ) FI
                                                  ON L.CDFILIAL = FI.CDFILIAL
                                                 AND L.NRORG = FI.NRORG ) FILO
                                         ON C.CDFILIAL = FILO.CDFILIAL
                                        AND C.CDLOJA = FILO.CDLOJA
                                        AND C.NRORG = FILO.NRORG) FILOCA
                                ON V.CDCAIXA = FILOCA.CDCAIXA
                               AND V.CDLOJA = FILOCA.CDLOJA
                               AND V.CDFILIAL = FILOCA.CDFILIAL
                               AND V.NRORG = FILOCA.NRORG
                             WHERE V.IDSITUVENDA = 'O'
                               AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                               AND V.IDORIGEMVENDA LIKE '%DLV%') FILOCAVE
                       ON FILOCAVE.CDOPERADOR = O.CDOPERADOR
                      AND FILOCAVE.NRORG = O.NRORG) FILOCAVEOP
                ON I.CDFILIAL = FILOCAVEOP.CDFILIAL
               AND I.CDCAIXA = FILOCAVEOP.CDCAIXA
               AND I.NRSEQVENDA = FILOCAVEOP.NRSEQVENDA
               AND I.NRORG = FILOCAVEOP.NRORG
             GROUP BY FILOCAVEOP.NMOPERADOR, FILOCAVEOP.IDSITUVENDA, FILOCAVEOP.NRSEQVENDA, FILOCAVEOP.CDCAIXA, FILOCAVEOP.NMCAIXA, FILOCAVEOP.CDLOJA, FILOCAVEOP.NMLOJA, FILOCAVEOP.CDFILIAL, 
                      FILOCAVEOP.NMFILIAL, FILOCAVEOP.CUPOM, FILOCAVEOP.CDOPERADOR, FILOCAVEOP.NRORG, FILOCAVEOP.DTVENDA, FILOCAVEOP.VRTXSEVENDA, FILOCAVEOP.VRCOMISVENDA, FILOCAVEOP.QTD
             ORDER BY FILOCAVEOP.CDFILIAL, FILOCAVEOP.CDLOJA, FILOCAVEOP.CDOPERADOR, FILOCAVEOP.DTVENDA, FILOCAVEOP.CUPOM
    ";
    
}